/*
 *  Copyright 2013-2050 Emmanuel BRUN (contact@amapj.fr)
 * 
 *  This file is part of AmapJ.
 *  
 *  AmapJ is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.

 *  AmapJ is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with AmapJ.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 */
 package fr.amapj.view.views.login.processsetpassword;

import fr.amapj.common.AmapjRuntimeException;
import fr.amapj.service.services.authentification.ProcessSetPasswordService;
import fr.amapj.service.services.authentification.ProcessSetPasswordService.ProcessSetPasswordInfo;
import fr.amapj.view.engine.popup.formpopup.WizardFormPopup;

/**
 * Le lien utilisé pour la saisie du nouveau password est expiré 
 * Le logiciel va l'afficher à l'utilisateur et celui ci pourra 
 * cliquer sur un bouton pour recevoir un nouveau lien 
 */
public class ProcessSetPasswordPopupExpiredLink extends WizardFormPopup
{
			
	private ProcessSetPasswordInfo utilisateurInfo;

	/**
	 * 
	 */
	public ProcessSetPasswordPopupExpiredLink(ProcessSetPasswordInfo utilisateurInfo)
	{
		this.utilisateurInfo = utilisateurInfo;
		
		if (utilisateurInfo.isLinkExpired==false || utilisateurInfo.isCreationPassword==true)
		{
			throw new AmapjRuntimeException();
		}
		
		popupTitle = "Lien expiré";
	}
	
	@Override
	protected void configure()
	{
		add(()->addStep1());
		add(()->addResultat());
	}
	
	protected void addStep1()
	{
		addHtml("Votre adresse email : "+utilisateurInfo.email);
		
		addHtml("Le lien que vous avez utilisé est trop ancien et n'est plus valable.");
		
		addHtml("En cliquant sur le bouton Suivant, un nouveau mail sera à votre adresse mail et vous permettra de ré initialiser votre mot de passe");	
	}
		
	private void addResultat()
	{	
		String msg = new ProcessSetPasswordService().sendMailForResetPassword(utilisateurInfo.email);
		if (msg==null)
		{
			msg = "Un mail vient de vous être envoyé. Merci de vérifier votre boîte mail";
		}
		addHtml(msg);		
		setAllButtonsAsOK();
	}

	@Override
	protected void performSauvegarder()
	{
		// Nothing to do
	}
}
